"""Demo code for cell generation.

Three synthetic cell images are generated by first generating cell
masks and finally by transfering the texture of a real cell image onto
the genrated masks.

"""
import pickle
from skimage.io import imread
from matplotlib import pyplot as plt
from time import time
from doodle_style_transfer import DoodleStyleTransfer
from cell_generation import generate_cell

# Load real cell image, real cell segmentation mask
xs = imread("./imgs/xs.png")
ms = imread("./imgs/ms.png")

doodle_style_transfer = DoodleStyleTransfer()

# Load trained CellMaskGenerator instance
cell_mask_generator_path = "./data/trained_cell_mask_generator.pkl"
with open(cell_mask_generator_path, 'rb') as f:
    cell_mask_generator = pickle.load(f)

# Generate new cells segmentations masks
# Generate synthetic cell images
t0 = time()
cell_count = 3
generated_cells = []
for _ in range(cell_count):
    xt, mt = generate_cell(xs,
                           ms,
                           cell_mask_generator,
                           doodle_style_transfer,
                           tol=0.075)
    generated_cells.append((xt, mt))
t1 = time()

print("Average generated image size = {:d} pixels".format(
    round(sum([m.size for _, m in generated_cells])/cell_count)))
print("Average generation time  = {:.2f} seconds".format((t1-t0)/cell_count))

# --- Display the results
fig, axes = plt.subplots(2, cell_count+1, figsize=(9, 4))

axes[0, 0].imshow(ms, cmap='gray')
axes[0, 0].set_title("Input")
axes[1, 0].imshow(xs)

for idx, (xt, mt) in enumerate(generated_cells):

    axes[0, idx+1].imshow(mt, cmap='gray')
    axes[0, idx+1].set_title("Output {}".format(idx+1))
    axes[1, idx+1].imshow(xt)

fig.set_tight_layout(True)
plt.show()
